package ru.ldeloff.servermonitorbot.service.command;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.telegram.telegrambots.meta.api.methods.send.SendMessage;
import ru.ldeloff.servermonitorbot.model.User;
import ru.ldeloff.servermonitorbot.service.role.RoleService;
import ru.ldeloff.servermonitorbot.service.user.UserService;
import ru.ldeloff.servermonitorbot.utils.ui.TelegramBotKeyboard;

@Service
@Slf4j
public class SwitchToMainMenu extends CommandTemplate {
    final TelegramBotKeyboard telegramBotKeyboard;

    public SwitchToMainMenu(UserService userService, RoleService roleService, TelegramBotKeyboard telegramBotKeyboard) {
        super(userService, roleService);
        this.telegramBotKeyboard = telegramBotKeyboard;
    }
    @Override
    public SendMessage actionForAuth(User user, SendMessage message) {
        message.setText("Неверная команда. Попробуем сначала.");
        return telegramBotKeyboard.uiForm(message);
    }
    @Override
    public void logSuccess(User user, String message) {
        log.warn("Получена несуществующая команда '" + message + "' от " + user.getLogin()
                + " (" + user.getTelegramId() + "). OK");
    }
    @Override
    public void logNotAuth(User user, String message) {
        log.warn("Получена несуществующая команда '" + message + "' от " + user.getLogin()
                + " (" + user.getTelegramId() + "). Нет прав");
    }
}
